package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.TarifaConvenioTransportDAO;
import com.rjconsultores.ventaboletos.entidad.TarifaConvenioTransport;

@SuppressWarnings("unchecked")
@Repository("tarifaConvenioTransportDAO")
public class TarifaConvenioTransportHibernateDAO extends GenericHibernateDAO<TarifaConvenioTransport, Long> implements TarifaConvenioTransportDAO {

    @Autowired
    public TarifaConvenioTransportHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

	@Override
    public List<TarifaConvenioTransport> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

	@Override
	public boolean gravarTarifasConvenio(List<TarifaConvenioTransport> tarifas) {

		for (TarifaConvenioTransport tarifa : tarifas) {
			if(tarifa.getTarifaConvenioId() == null) {
				suscribir(tarifa);
			}else {
				actualizacion(tarifa);
			}
		}

		return true;
	}
}
